#!/bin/bash
# THIS FILE IS PART OF THE CYLC SUITE ENGINE.
# Copyright (C) 2008-2018 NIWA & British Crown (Met Office) & Contributors.
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#-------------------------------------------------------------------------------
# basic EmPy expansion test
. $(dirname $0)/test_header
if ! cylc check-software EmPy; then
    skip_all '"EmPy" not installed'
fi
#-------------------------------------------------------------------------------
set_test_number 2
#-------------------------------------------------------------------------------
install_suite $TEST_NAME_BASE 00-simple
#-------------------------------------------------------------------------------
TEST_NAME=$TEST_NAME_BASE-validate
run_ok $TEST_NAME cylc validate -o 'suite.rc.processed' "${SUITE_NAME}"
#-------------------------------------------------------------------------------
TEST_NAME=$TEST_NAME_BASE-check-expansion
cmp_ok 'suite.rc.processed' $TEST_SOURCE_DIR/00-simple/suite.rc-expanded
#-------------------------------------------------------------------------------
purge_suite $SUITE_NAME
